/[gentoo-x86]/eclass/mysql.eclass
Gentoo

Diff of /eclass/mysql.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.149 Revision 1.163
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2009 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.149 2010/08/20 23:52:51 robbat2 Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.163 2011/08/21 16:14:56 jmbsvicetto Exp $
4 4
5# @ECLASS: mysql.eclass 5# @ECLASS: mysql.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Author: Francesco Riosa (Retired) <vivo@gentoo.org> 7# Author: Francesco Riosa (Retired) <vivo@gentoo.org>
8# Maintainers: MySQL Team <mysql-bugs@gentoo.org> 8# Maintainers: MySQL Team <mysql-bugs@gentoo.org>
143 143
144RDEPEND="${DEPEND} 144RDEPEND="${DEPEND}
145 !minimal? ( dev-db/mysql-init-scripts ) 145 !minimal? ( dev-db/mysql-init-scripts )
146 selinux? ( sec-policy/selinux-mysql )" 146 selinux? ( sec-policy/selinux-mysql )"
147 147
148DEPEND="${DEPEND}
149 virtual/yacc"
150
151if [ "${EAPI:-0}" = "2" ]; then
152 DEPEND="${DEPEND} static? ( || ( sys-libs/ncurses[static-libs] <=sys-libs/ncurses-5.7-r3 ) )"
153fi
154
148# compile-time-only 155# compile-time-only
149mysql_version_is_at_least "5.1" \ 156mysql_version_is_at_least "5.1" \
150|| DEPEND="${DEPEND} berkdb? ( sys-apps/ed )" 157|| DEPEND="${DEPEND} berkdb? ( sys-apps/ed )"
151 158
152# compile-time-only 159# compile-time-only
153mysql_version_is_at_least "5.1.12" \ 160mysql_version_is_at_least "5.1.12" \
154&& DEPEND="${DEPEND} >=dev-util/cmake-2.4.3" 161&& DEPEND="${DEPEND} >=dev-util/cmake-2.4.3"
162
163[[ "${PN}" == "mariadb" ]] \
164&& mysql_version_is_at_least "5.2" \
165&& DEPEND="${DEPEND} oqgraph? ( >=dev-libs/boost-1.40.0 )"
166#SphinxSE is included but is not available in 5.2.4 due to a missing plug.in file
167# sphinx? ( app-misc/sphinx )"
155 168
156# dev-perl/DBD-mysql is needed by some scripts installed by MySQL 169# dev-perl/DBD-mysql is needed by some scripts installed by MySQL
157PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )" 170PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )"
158 171
159# For other stuff to bring us in 172# For other stuff to bring us in
164 [ -z "${MY_PV}" ] && MY_PV="${PV//_/-}" 177 [ -z "${MY_PV}" ] && MY_PV="${PV//_/-}"
165 if [ "${PN}" == "mariadb" ]; then 178 if [ "${PN}" == "mariadb" ]; then
166 MARIA_FULL_PV="$(replace_version_separator 3 '-' ${PV})" 179 MARIA_FULL_PV="$(replace_version_separator 3 '-' ${PV})"
167 MARIA_FULL_P="${PN}-${MARIA_FULL_PV}" 180 MARIA_FULL_P="${PN}-${MARIA_FULL_PV}"
168 SERVER_URI=" 181 SERVER_URI="
182 http://ftp.osuosl.org/pub/mariadb/${MARIA_FULL_P}/kvm-tarbake-jaunty-x86/${MARIA_FULL_P}.tar.gz
169 http://ftp.rediris.es/mirror/MariaDB/${MARIA_FULL_P}/kvm-tarbake-jaunty-x86/${MARIA_FULL_P}.tar.gz 183 http://ftp.rediris.es/mirror/MariaDB/${MARIA_FULL_P}/kvm-tarbake-jaunty-x86/${MARIA_FULL_P}.tar.gz
170 http://maria.llarian.net/download/${MARIA_FULL_P}/kvm-tarbake-jaunty-x86/${MARIA_FULL_P}.tar.gz 184 http://maria.llarian.net/download/${MARIA_FULL_P}/kvm-tarbake-jaunty-x86/${MARIA_FULL_P}.tar.gz
171 http://launchpad.net/maria/${MYSQL_PV_MAJOR}/ongoing/+download/${MARIA_FULL_P}.tar.gz 185 http://launchpad.net/maria/${MYSQL_PV_MAJOR}/ongoing/+download/${MARIA_FULL_P}.tar.gz
186 http://mirrors.fe.up.pt/pub/${PN}/${MARIA_FULL_P}/kvm-tarbake-jaunty-x86/${MARIA_FULL_P}.tar.gz
187 http://ftp-stud.hs-esslingen.de/pub/Mirrors/${PN}/${MARIA_FULL_P}/kvm-tarbake-jaunty-x86/${MARIA_FULL_P}.tar.gz
172 " 188 "
173 # The community and cluster builds are on the mirrors 189 # The community and cluster builds are on the mirrors
174 elif [[ "${MYSQL_COMMUNITY_FEATURES}" == "1" || ${PN} == "mysql-cluster" ]] ; then 190 elif [[ "${MYSQL_COMMUNITY_FEATURES}" == "1" || ${PN} == "mysql-cluster" ]] ; then
175 if [[ "${PN}" == "mysql-cluster" ]] ; then 191 if [[ "${PN}" == "mysql-cluster" ]] ; then
176 URI_DIR="MySQL-Cluster" 192 URI_DIR="MySQL-Cluster"
236&& IUSE="${IUSE} ${IUSE_DEFAULT_ON}community profiling" 252&& IUSE="${IUSE} ${IUSE_DEFAULT_ON}community profiling"
237 253
238[[ "${PN}" == "mariadb" ]] \ 254[[ "${PN}" == "mariadb" ]] \
239&& IUSE="${IUSE} libevent" 255&& IUSE="${IUSE} libevent"
240 256
257[[ "${PN}" == "mariadb" ]] \
258&& mysql_version_is_at_least "5.2" \
259&& IUSE="${IUSE} oqgraph"
260#SphinxSE is included but is not available in 5.2.4 due to a missing plug.in file
261#&& IUSE="${IUSE} oqgraph sphinx"
262
241# MariaDB has integrated PBXT 263# MariaDB has integrated PBXT
242# PBXT_VERSION means that we have a PBXT patch for this PV 264# PBXT_VERSION means that we have a PBXT patch for this PV
243# PBXT was only introduced after 5.1.12 265# PBXT was only introduced after 5.1.12
244pbxt_patch_available() { 266pbxt_patch_available() {
245 [[ "${PN}" != "mariadb" ]] \ 267 [[ "${PN}" != "mariadb" ]] \
298mysql_disable_test() { 320mysql_disable_test() {
299 local rawtestname testname testsuite reason mysql_disable_file 321 local rawtestname testname testsuite reason mysql_disable_file
300 rawtestname="${1}" ; shift 322 rawtestname="${1}" ; shift
301 reason="${@}" 323 reason="${@}"
302 ewarn "test '${rawtestname}' disabled: '${reason}'" 324 ewarn "test '${rawtestname}' disabled: '${reason}'"
303 325
304 testsuite="${rawtestname/.*}" 326 testsuite="${rawtestname/.*}"
305 testname="${rawtestname/*.}" 327 testname="${rawtestname/*.}"
306 mysql_disable_file="${S}/mysql-test/t/disabled.def" 328 mysql_disable_file="${S}/mysql-test/t/disabled.def"
307 #einfo "rawtestname=${rawtestname} testname=${testname} testsuite=${testsuite}" 329 #einfo "rawtestname=${rawtestname} testname=${testname} testsuite=${testsuite}"
308 echo ${testname} : ${reason} >> "${mysql_disable_file}" 330 echo ${testname} : ${reason} >> "${mysql_disable_file}"
568 myconf="${myconf} --with-readline" 590 myconf="${myconf} --with-readline"
569 myconf="${myconf} --with-zlib-dir=/usr/" 591 myconf="${myconf} --with-zlib-dir=/usr/"
570 myconf="${myconf} --without-pstack" 592 myconf="${myconf} --without-pstack"
571 myconf="${myconf} --with-plugindir=/usr/$(get_libdir)/mysql/plugin" 593 myconf="${myconf} --with-plugindir=/usr/$(get_libdir)/mysql/plugin"
572 594
595 # This is an explict die here, because if we just forcibly disable it, then the
596 # user's data is not accessible.
597 use max-idx-128 && die "Bug #336027: upstream has a corruption issue with max-idx-128 presently"
573 use max-idx-128 && myconf="${myconf} --with-max-indexes=128" 598 #use max-idx-128 && myconf="${myconf} --with-max-indexes=128"
574 if [ "${MYSQL_COMMUNITY_FEATURES}" == "1" ]; then 599 if [ "${MYSQL_COMMUNITY_FEATURES}" == "1" ]; then
575 myconf="${myconf} $(use_enable community community-features)" 600 myconf="${myconf} $(use_enable community community-features)"
576 if use community; then 601 if use community; then
577 myconf="${myconf} $(use_enable profiling)" 602 myconf="${myconf} $(use_enable profiling)"
578 else 603 else
614 fi 639 fi
615 # Now the extras 640 # Now the extras
616 if use extraengine ; then 641 if use extraengine ; then
617 # like configuration=max-no-ndb, archive and example removed in 5.1.11 642 # like configuration=max-no-ndb, archive and example removed in 5.1.11
618 # not added yet: ibmdb2i 643 # not added yet: ibmdb2i
619 # Not supporting as examples: example,daemon_example,ftexample 644 # Not supporting as examples: example,daemon_example,ftexample
620 plugins_sta="${plugins_sta} partition" 645 plugins_sta="${plugins_sta} partition"
621 plugins_dyn="${plugins_sta} federated"
622 646
623 if [[ "${PN}" != "mariadb" ]] ; then 647 if [[ "${PN}" != "mariadb" ]] ; then
624 elog "Before using the Federated storage engine, please be sure to read" 648 elog "Before using the Federated storage engine, please be sure to read"
625 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html" 649 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html"
650 plugins_dyn="${plugins_sta} federated"
626 else 651 else
627 elog "MariaDB includes the FederatedX engine. Be sure to read" 652 elog "MariaDB includes the FederatedX engine. Be sure to read"
628 elog "http://askmonty.org/wiki/index.php/Manual:FederatedX_storage_engine" 653 elog "http://askmonty.org/wiki/index.php/Manual:FederatedX_storage_engine"
654 plugins_dyn="${plugins_sta} federatedx"
629 fi 655 fi
630 else 656 else
631 plugins_dis="${plugins_dis} partition federated" 657 plugins_dis="${plugins_dis} partition federated"
632 fi 658 fi
633 659
651 fi 677 fi
652 678
653 if [[ "${PN}" == "mariadb" ]] ; then 679 if [[ "${PN}" == "mariadb" ]] ; then
654 # In MariaDB, InnoDB is packaged in the xtradb directory, so it's not 680 # In MariaDB, InnoDB is packaged in the xtradb directory, so it's not
655 # caught above. 681 # caught above.
656 plugins_sta="${plugins_sta} maria innobase"
657 myconf="${myconf} $(use_with libevent)"
658 # This is not optional, without it several upstream testcases fail. 682 # This is not optional, without it several upstream testcases fail.
659 # Also strongly recommended by upstream. 683 # Also strongly recommended by upstream.
684 if [[ "${PV}" < "5.2.0" ]] ; then
660 myconf="${myconf} --with-maria-tmp-tables" 685 myconf="${myconf} --with-maria-tmp-tables"
686 plugins_sta="${plugins_sta} maria"
687 else
688 myconf="${myconf} --with-aria-tmp-tables"
689 plugins_sta="${plugins_sta} aria"
661 fi 690 fi
662 691
692 [ -e "${S}"/storage/innobase ] || [ -e "${S}"/storage/xtradb ] ||
693 die "The ${P} package doesn't provide innobase nor xtradb"
694
695 for i in innobase xtradb ; do
696 [ -e "${S}"/storage/${i} ] && plugins_sta="${plugins_sta} ${i}"
697 done
698
699 myconf="${myconf} $(use_with libevent)"
700
701 if mysql_version_is_at_least "5.2" ; then
702 #This should include sphinx, but the 5.2.4 archive forgot the plug.in file
703 #for i in oqgraph sphinx ; do
704 for i in oqgraph ; do
705 use ${i} \
706 && plugins_dyn="${plugins_dyn} ${i}" \
707 || plugins_dis="${plugins_dis} ${i}"
708 done
709 fi
710 fi
711
663 if pbxt_available && [[ "${PBXT_NEWSTYLE}" == "1" ]]; then 712 if pbxt_available && [[ "${PBXT_NEWSTYLE}" == "1" ]]; then
664 use pbxt \ 713 use pbxt \
665 && plugins_dyn="${plugins_dyn} pbxt" \ 714 && plugins_dyn="${plugins_dyn} pbxt" \
666 || plugins_dis="${plugins_dis} pbxt" 715 || plugins_dis="${plugins_dis} pbxt"
667 fi 716 fi
668 717
669 use static && \ 718 use static && \
670 plugins_sta="${plugins_sta} ${plugins_dyn}" && \ 719 plugins_sta="${plugins_sta} ${plugins_dyn}" && \
671 plugins_dyn="" 720 plugins_dyn=""
672 721
673 einfo "Available plugins: ${plugins_avail}" 722 einfo "Available plugins: ${plugins_avail}"
674 einfo "Dynamic plugins: ${plugins_dyn}" 723 einfo "Dynamic plugins: ${plugins_dyn}"
675 einfo "Static plugins: ${plugins_sta}" 724 einfo "Static plugins: ${plugins_sta}"
676 einfo "Disabled plugins: ${plugins_dis}" 725 einfo "Disabled plugins: ${plugins_dis}"
677 726
687 mysql_init_vars 736 mysql_init_vars
688 737
689 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null 738 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null
690 739
691 einfo "Reconfiguring dir '${PWD}'" 740 einfo "Reconfiguring dir '${PWD}'"
692 AT_GNUCONF_UPDATE="yes" eautoreconf 741 eautoreconf
693 742
694 local myconf="" 743 local myconf=""
695 myconf="${myconf} --with-mysql=${S} --libdir=/usr/$(get_libdir)" 744 myconf="${myconf} --with-mysql=${S} --libdir=/usr/$(get_libdir)"
696 use debug && myconf="${myconf} --with-debug=full" 745 use debug && myconf="${myconf} --with-debug=full"
697 econf ${myconf} || die "Problem configuring PBXT storage engine" 746 econf ${myconf} || die "Problem configuring PBXT storage engine"
725# die if FEATURES="test", USE="-minimal" and not using FEATURES="userpriv" 774# die if FEATURES="test", USE="-minimal" and not using FEATURES="userpriv"
726# check for conflicting use flags 775# check for conflicting use flags
727# create new user and group for mysql 776# create new user and group for mysql
728# warn about deprecated features 777# warn about deprecated features
729mysql_pkg_setup() { 778mysql_pkg_setup() {
730 if hasq test ${FEATURES} ; then 779 if has test ${FEATURES} ; then
731 if ! use minimal ; then 780 if ! use minimal ; then
732 if [[ $UID -eq 0 ]]; then 781 if [[ $UID -eq 0 ]]; then
733 eerror "Testing with FEATURES=-userpriv is no longer supported by upstream. Tests MUST be run as non-root." 782 eerror "Testing with FEATURES=-userpriv is no longer supported by upstream. Tests MUST be run as non-root."
734 fi 783 fi
735 fi 784 fi
736 fi 785 fi
786
787 # bug 350844
788 case "${EAPI:-0}" in
789 0 | 1)
790 if use static && !built_with_use sys-libs/ncurses static-libs; then
791 die "To build MySQL statically you need to enable static-libs for sys-libs/ncurses"
792 fi
793 ;;
794 esac
737 795
738 # Check for USE flag problems in pkg_setup 796 # Check for USE flag problems in pkg_setup
739 if use static && use ssl ; then 797 if use static && use ssl ; then
740 M="MySQL does not support being built statically with SSL support enabled!" 798 M="MySQL does not support being built statically with SSL support enabled!"
741 eerror "${M}" 799 eerror "${M}"
742 die "${M}" 800 die "${M}"
801 fi
802
803 if mysql_version_is_at_least "5.1.51" \
804 && ! mysql_version_is_at_least "5.2" \
805 && use debug ; then
806 # Also in package.use.mask
807 die "Bug #344885: Upstream has broken USE=debug for 5.1 series >=5.1.51"
743 fi 808 fi
744 809
745 if ! mysql_version_is_at_least "5.0" \ 810 if ! mysql_version_is_at_least "5.0" \
746 && use raid \ 811 && use raid \
747 && use static ; then 812 && use static ; then
755 && use minimal ; then 820 && use minimal ; then
756 M="USE flags 'cluster', 'extraengine', 'embedded' conflict with 'minimal' USE flag!" 821 M="USE flags 'cluster', 'extraengine', 'embedded' conflict with 'minimal' USE flag!"
757 eerror "${M}" 822 eerror "${M}"
758 die "${M}" 823 die "${M}"
759 fi 824 fi
760 825
761 if mysql_version_is_at_least "5.1" \ 826 if mysql_version_is_at_least "5.1" \
762 && xtradb_patch_available \ 827 && xtradb_patch_available \
763 && use xtradb \ 828 && use xtradb \
764 && use embedded ; then 829 && use embedded ; then
765 M="USE flags 'xtradb' and 'embedded' conflict and cause build failures" 830 M="USE flags 'xtradb' and 'embedded' conflict and cause build failures"
771 # Upstream changes made us need a fairly new GCC4. 836 # Upstream changes made us need a fairly new GCC4.
772 # But only for 5.0.8[3-6]! 837 # But only for 5.0.8[3-6]!
773 if mysql_version_is_at_least "5.0.83" && ! mysql_version_is_at_least 5.0.87 ; then 838 if mysql_version_is_at_least "5.0.83" && ! mysql_version_is_at_least 5.0.87 ; then
774 GCC_VER=$(gcc-version) 839 GCC_VER=$(gcc-version)
775 case ${GCC_VER} in 840 case ${GCC_VER} in
776 2*|3*|4.0|4.1|4.2) 841 2*|3*|4.0|4.1|4.2)
777 eerror "Some releases of MySQL required a very new GCC, and then" 842 eerror "Some releases of MySQL required a very new GCC, and then"
778 eerror "later release relaxed that requirement again. Either pick a" 843 eerror "later release relaxed that requirement again. Either pick a"
779 eerror "MySQL >=5.0.87, or use a newer GCC." 844 eerror "MySQL >=5.0.87, or use a newer GCC."
780 die "Active GCC too old!" ;; 845 die "Active GCC too old!" ;;
781 esac 846 esac
835 mysql_mv_patches 900 mysql_mv_patches
836 # And apply 901 # And apply
837 epatch 902 epatch
838 903
839 # last -fPIC fixup, per bug #305873 904 # last -fPIC fixup, per bug #305873
840 i="${S}"/storage/innodb_plugin/plug.in 905 i="${S}"/storage/innodb_plugin/plug.in
841 [ -f "${i}" ] && sed -i -e '/CFLAGS/s,-prefer-non-pic,,g' "${i}" 906 [ -f "${i}" ] && sed -i -e '/CFLAGS/s,-prefer-non-pic,,g' "${i}"
842 907
843 # Additional checks, remove bundled zlib (Cluster needs this, for static 908 # Additional checks, remove bundled zlib (Cluster needs this, for static
844 # memory management in zlib, leave available for Cluster) 909 # memory management in zlib, leave available for Cluster)
845 if [[ "${PN}" != "mysql-cluster" ]] ; then 910 if [[ "${PN}" != "mysql-cluster" ]] ; then
875 # Or maybe we haven't 940 # Or maybe we haven't
876 [ -d "${i}" -a ! -d "${o}" ] && mv "${i}" "${o}" 941 [ -d "${i}" -a ! -d "${o}" ] && mv "${i}" "${o}"
877 cp -ral "${WORKDIR}/${XTRADB_P}" "${i}" 942 cp -ral "${WORKDIR}/${XTRADB_P}" "${i}"
878 popd >/dev/null 943 popd >/dev/null
879 fi 944 fi
880 945
881 if pbxt_available && [[ "${PBXT_NEWSTYLE}" == "1" ]] && use pbxt ; then 946 if pbxt_patch_available && [[ "${PBXT_NEWSTYLE}" == "1" ]] && use pbxt ; then
882 einfo "Adding storage engine: PBXT" 947 einfo "Adding storage engine: PBXT"
883 pushd "${S}"/storage >/dev/null 948 pushd "${S}"/storage >/dev/null
884 i='pbxt' 949 i='pbxt'
885 [ -d "${i}" ] && rm -rf "${i}" 950 [ -d "${i}" ] && rm -rf "${i}"
886 cp -ral "${WORKDIR}/${PBXT_P}" "${i}" 951 cp -ral "${WORKDIR}/${PBXT_P}" "${i}"
901 fi 966 fi
902 967
903 for d in ${rebuilddirlist} ; do 968 for d in ${rebuilddirlist} ; do
904 einfo "Reconfiguring dir '${d}'" 969 einfo "Reconfiguring dir '${d}'"
905 pushd "${d}" &>/dev/null 970 pushd "${d}" &>/dev/null
906 AT_GNUCONF_UPDATE="yes" eautoreconf 971 eautoreconf
907 popd &>/dev/null 972 popd &>/dev/null
908 done 973 done
909 974
910 if mysql_check_version_range "4.1 to 5.0.99.99" \ 975 if mysql_check_version_range "4.1 to 5.0.99.99" \
911 && use berkdb ; then 976 && use berkdb ; then
967 export CXXFLAGS 1032 export CXXFLAGS
968 1033
969 # bug #283926, with GCC4.4, this is required to get correct behavior. 1034 # bug #283926, with GCC4.4, this is required to get correct behavior.
970 append-flags -fno-strict-aliasing 1035 append-flags -fno-strict-aliasing
971 1036
1037 # bug #335185, #335995, with >= GCC4.3.3 on x86 only, omit-frame-pointer
1038 # causes a mis-compile.
1039 # Upstream bugs:
1040 # http://gcc.gnu.org/bugzilla/show_bug.cgi?id=38562
1041 # http://bugs.mysql.com/bug.php?id=45205
1042 use x86 && version_is_at_least "4.3.3" "$(gcc-fullversion)" && \
1043 append-flags -fno-omit-frame-pointer && \
1044 filter-flags -fomit-frame-pointer
1045
972 econf \ 1046 econf \
973 --libexecdir="/usr/sbin" \ 1047 --libexecdir="/usr/sbin" \
974 --sysconfdir="${MY_SYSCONFDIR}" \ 1048 --sysconfdir="${MY_SYSCONFDIR}" \
975 --localstatedir="${MY_LOCALSTATEDIR}" \ 1049 --localstatedir="${MY_LOCALSTATEDIR}" \
976 --sharedstatedir="${MY_SHAREDSTATEDIR}" \ 1050 --sharedstatedir="${MY_SHAREDSTATEDIR}" \
979 --with-low-memory \ 1053 --with-low-memory \
980 --with-client-ldflags=-lstdc++ \ 1054 --with-client-ldflags=-lstdc++ \
981 --enable-thread-safe-client \ 1055 --enable-thread-safe-client \
982 --with-comment="Gentoo Linux ${PF}" \ 1056 --with-comment="Gentoo Linux ${PF}" \
983 --without-docs \ 1057 --without-docs \
1058 --with-LIBDIR="$(get_libdir)" \
984 ${myconf} || die "econf failed" 1059 ${myconf} || die "econf failed"
985 1060
986 # TODO: Move this before autoreconf !!! 1061 # TODO: Move this before autoreconf !!!
987 find . -type f -name Makefile -print0 \ 1062 find . -type f -name Makefile -print0 \
988 | xargs -0 -n100 sed -i \ 1063 | xargs -0 -n100 sed -i \
1057 if use !test ; then 1132 if use !test ; then
1058 rm -rf "${D}"/${MY_SHAREDSTATEDIR}/mysql-test 1133 rm -rf "${D}"/${MY_SHAREDSTATEDIR}/mysql-test
1059 fi 1134 fi
1060 1135
1061 # Configuration stuff 1136 # Configuration stuff
1062 if mysql_version_is_at_least "5.1" ; then 1137 case ${MYSQL_PV_MAJOR} in
1063 mysql_mycnf_version="5.1"
1064 elif mysql_version_is_at_least "4.1" ; then
1065 mysql_mycnf_version="4.1"
1066 else
1067 mysql_mycnf_version="4.0" 1138 3*|4.0) mysql_mycnf_version="4.0" ;;
1068 fi 1139 4.[1-9]|5.0) mysql_mycnf_version="4.1" ;;
1069 einfo "Building default my.cnf" 1140 5.[1-9]|6*|7*) mysql_mycnf_version="5.1" ;;
1141 esac
1142 einfo "Building default my.cnf (${mysql_mycnf_version})"
1070 insinto "${MY_SYSCONFDIR}" 1143 insinto "${MY_SYSCONFDIR}"
1071 doins scripts/mysqlaccess.conf 1144 doins scripts/mysqlaccess.conf
1145 mycnf_src="my.cnf-${mysql_mycnf_version}"
1072 sed -e "s!@DATADIR@!${MY_DATADIR}!g" \ 1146 sed -e "s!@DATADIR@!${MY_DATADIR}!g" \
1073 "${FILESDIR}/my.cnf-${mysql_mycnf_version}" \ 1147 "${FILESDIR}/${mycnf_src}" \
1074 > "${TMPDIR}/my.cnf.ok" 1148 > "${TMPDIR}/my.cnf.ok"
1075 if mysql_version_is_at_least "4.1" && use latin1 ; then 1149 if use latin1 ; then
1076 sed -i \ 1150 sed -i \
1077 -e "/character-set/s|utf8|latin1|g" \ 1151 -e "/character-set/s|utf8|latin1|g" \
1078 "${TMPDIR}/my.cnf.ok" 1152 "${TMPDIR}/my.cnf.ok"
1079 fi 1153 fi
1080 newins "${TMPDIR}/my.cnf.ok" my.cnf 1154 newins "${TMPDIR}/my.cnf.ok" my.cnf
1098 done 1172 done
1099 fi 1173 fi
1100 1174
1101 # Docs 1175 # Docs
1102 einfo "Installing docs" 1176 einfo "Installing docs"
1103 dodoc README ChangeLog EXCEPTIONS-CLIENT INSTALL-SOURCE 1177 for i in README ChangeLog EXCEPTIONS-CLIENT INSTALL-SOURCE ; do
1178 [[ -f "$i" ]] && dodoc "$i"
1179 done
1104 doinfo "${S}"/Docs/mysql.info 1180 doinfo "${S}"/Docs/mysql.info
1105 1181
1106 # Minimal builds don't have the MySQL server 1182 # Minimal builds don't have the MySQL server
1107 if ! use minimal ; then 1183 if ! use minimal ; then
1108 einfo "Including support files and sample configurations" 1184 einfo "Including support files and sample configurations"
1174 1250
1175 einfo 1251 einfo
1176 elog "You might want to run:" 1252 elog "You might want to run:"
1177 elog "\"emerge --config =${CATEGORY}/${PF}\"" 1253 elog "\"emerge --config =${CATEGORY}/${PF}\""
1178 elog "if this is a new install." 1254 elog "if this is a new install."
1255 einfo
1256
1257 einfo
1258 elog "If you are upgrading major versions, you should run the"
1259 elog "mysql_upgrade tool."
1179 einfo 1260 einfo
1180 fi 1261 fi
1181 1262
1182 if pbxt_available && use pbxt ; then 1263 if pbxt_available && use pbxt ; then
1183 # TODO: explain it better 1264 # TODO: explain it better
1238 fi 1319 fi
1239 fi 1320 fi
1240 1321
1241 local pwd1="a" 1322 local pwd1="a"
1242 local pwd2="b" 1323 local pwd2="b"
1243 local MYSQL_ROOT_PASSWORD=''
1244 local maxtry=15 1324 local maxtry=15
1245 1325
1246 if [ -z "${MYSQL_ROOT_PASSWORD}" -a -f "${ROOT}/root/.my.cnf" ]; then 1326 if [ -z "${MYSQL_ROOT_PASSWORD}" -a -f "${ROOT}/root/.my.cnf" ]; then
1247 MYSQL_ROOT_PASSWORD="$(sed -n -e '/^password=/s,^password=,,gp' "${ROOT}/root/.my.cnf")" 1327 MYSQL_ROOT_PASSWORD="$(sed -n -e '/^password=/s,^password=,,gp' "${ROOT}/root/.my.cnf")"
1248 fi 1328 fi
1258 # localhost. Also causes weird failures. 1338 # localhost. Also causes weird failures.
1259 [[ "${HOSTNAME}" == "localhost" ]] && die "Your machine must NOT be named localhost" 1339 [[ "${HOSTNAME}" == "localhost" ]] && die "Your machine must NOT be named localhost"
1260 1340
1261 if [ -z "${MYSQL_ROOT_PASSWORD}" ]; then 1341 if [ -z "${MYSQL_ROOT_PASSWORD}" ]; then
1262 1342
1263 einfo "Please provide a password for the mysql 'root' user now," 1343 einfo "Please provide a password for the mysql 'root' user now, in the"
1264 einfo "or in the MYSQL_ROOT_PASSWORD env var." 1344 einfo "MYSQL_ROOT_PASSWORD env var or through the /root/.my.cnf file."
1265 ewarn "Avoid [\"'\\_%] characters in the password" 1345 ewarn "Avoid [\"'\\_%] characters in the password"
1266 read -rsp " >" pwd1 ; echo 1346 read -rsp " >" pwd1 ; echo
1267 1347
1268 einfo "Retype the password" 1348 einfo "Retype the password"
1269 read -rsp " >" pwd2 ; echo 1349 read -rsp " >" pwd2 ; echo
1317 1397
1318 if [[ -r "${help_tables}" ]] ; then 1398 if [[ -r "${help_tables}" ]] ; then
1319 cat "${help_tables}" >> "${sqltmp}" 1399 cat "${help_tables}" >> "${sqltmp}"
1320 fi 1400 fi
1321 fi 1401 fi
1322 1402
1323 einfo "Creating the mysql database and setting proper" 1403 einfo "Creating the mysql database and setting proper"
1324 einfo "permissions on it ..." 1404 einfo "permissions on it ..."
1325 1405
1326 local socket="${ROOT}/var/run/mysqld/mysqld${RANDOM}.sock" 1406 local socket="${ROOT}/var/run/mysqld/mysqld${RANDOM}.sock"
1327 local pidfile="${ROOT}/var/run/mysqld/mysqld${RANDOM}.pid" 1407 local pidfile="${ROOT}/var/run/mysqld/mysqld${RANDOM}.pid"

Legend:
Removed from v.1.149  
changed lines
  Added in v.1.163

  ViewVC Help
Powered by ViewVC 1.1.20